export filepath, filepaths

abstract type AbstractFile end

function filepaths(::T) where {T<:AbstractFile} end
function filepath(::T, idx::Int) where {T<:AbstractFile} end

macro filetype(ftype, suptype)
    return esc(quote
        """
            $($ftype) <: $($supertype)

        A type representing $($ftype) files.
        """
        struct $ftype{N} <: $suptype
            files::NTuple{N,String}
        end
        function $(ftype)(files...)
            $ftype{length(files)}(files)
        end

        function filepath(ft::$ftype, idx::Int = 1)
            return ft.files[idx]
        end
        function filepaths(ft::$ftype)
            return ft.files
        end
    end)
end

for fn in (:JSON, :TXT, :YAML)
    @eval begin
        @filetype $fn AbstractFile
        export $fn
    end
end
